/**********************************************************************
* @file		main_conf.h
* @brief	Contains all macro definitions and function prototypes
* 			support for PCU firmware library on A33M11x
* @version	1.0
* @date		
* @author	ABOV M team
*
* Copyright(C) 2017, ABOV Semiconductor
* All rights reserved.
*
**********************************************************************/
#ifndef __A33M11x_CONF_H
#define __A33M11x_CONF_H

#ifdef __cplusplus
extern "C" {
#endif
	
/* Includes ------------------------------------------------------------------*/
/* Uncomment the line below to enable peripheral header file inclusion */
#include "A33M11x_hal_pcu.h"
#include "A33M11x_hal_scu.h"
#include "A33M11x_hal_cfmc.h"
#include "A33M11x_hal_dfmc.h"
#include "A33M11x_hal_libcfg.h"
#include "A33M11x_hal_debug_frmwrk.h"
#include "A33M11x_it.h"

#ifdef __cplusplus
extern "C"
{
#endif	
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/


/* Private function prototypes -----------------------------------------------*/

/* Initialize all port */
extern void Port_Init(void); 
/* Configure the system clock to 8 MHz */
extern void SystemClock_Config(void);
	
	/* 	Error_Handler */
void Error_Handler(void);	
	
#ifdef __cplusplus
}
#endif

#endif /* __A33M11x_CONF_H */


